"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var React = require("react");
/**
 * The DynamicModuleLoader adds a way to register a module on mount
 * When this component is initialized, the reducer and saga from the module passed as props will be registered with the system
 * On unmount, they will be unregistered
 */
var DynamicModuleLoader = /** @class */ (function (_super) {
    __extends(DynamicModuleLoader, _super);
    function DynamicModuleLoader(props, context) {
        var _this = _super.call(this, props, context) || this;
        var modules = props.modules;
        var store = context.store;
        if (!store) {
            throw new Error("Could not load store from React context.");
        }
        _this._addedModules = store.addModule.apply(store, modules);
        return _this;
    }
    /**
     * Unregister sagas and reducers
     */
    DynamicModuleLoader.prototype.componentWillUnmount = function () {
        if (this._addedModules) {
            this._addedModules.remove();
            this._addedModules = undefined;
        }
    };
    /**
     * Render a Redux provider
     */
    DynamicModuleLoader.prototype.render = function () {
        return this.props.children;
    };
    return DynamicModuleLoader;
}(React.Component));
exports.DynamicModuleLoader = DynamicModuleLoader;
